<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Helpers;

class TemplateArgumentsListFilter
{
    protected $attributeList;

    protected $blackAttributeList = array();

    public function __construct()
    {
    }

    public function getAttributeList($targetModule = '')
    {
        if (empty($targetModule)) {
            return array();
        }elseif (!isset($this->attributeList[$targetModule])) {
            $this->setAttributeList($targetModule);
        }
        return $this->attributeList[$targetModule];
    }

    protected function setAttributeList($targetModule)
    {
        $targetBean = \BeanFactory::getBean($targetModule);
        if(empty($targetBean)){
            $this->attributeList[$targetModule] = array();
            return;
        }

        $dateTargetFieldsFields = array();

        foreach ($targetBean->field_defs as $fieldDefs) {
            if (
//                $this->fieldIsStoredInDatabase($fieldDefs) &&
                $this->fieldHasNameAttribute($fieldDefs)
            ) {
                $dateTargetFieldsFields[$fieldDefs['name']] = $this->getFieldLabel($targetModule, $fieldDefs);
            }
        }

        $this->attributeList[$targetModule] = $dateTargetFieldsFields;
//        return $this->attributeList[$targetModule];
    }

    protected function fieldIsStoredInDatabase($fieldDefs){
        return empty($fieldDefs['source']) || $fieldDefs['source'] != 'non-db';
    }

    protected function fieldHasNameAttribute($fieldDefs){
        return !empty($fieldDefs['name']);
    }

    protected function getFieldLabel($targetModule, $fieldDefs){
        $fieldName = $fieldDefs['name'];
        $labelKey = !empty($fieldDefs['vname']) ? $fieldDefs['vname'] : '';
        $labelValue = translate($labelKey, $targetModule);

        if(!empty($labelValue)){
            $labelValue = $this->removeColonFromTheEndOfSomeLabels($labelValue);
            return $labelValue . ' (' . $fieldName . ')';
        }

        return $fieldName;
    }

    private function removeColonFromTheEndOfSomeLabels($label){
        return preg_replace ( '/(.*)(:+)$/' , '$1' , trim($label));

    }

}