(function(app) {
    app.events.on('app:init', function(router) {

        if (("Notification" in window) && Notification.permission !== 'denied') {

            var delayInMilliseconds = 1000 * 60 * 1,
                date = app.date().subtract(delayInMilliseconds).formatServer(),
                notificationFunc = function (datetime) {

                    var url = app.api.buildURL('pxntdv/notifications' /*/'+datetime*/, '', {}, {});
                    app.api.call('read', url, null, {
                        success: function (response) {

                            _.each(response.records, function (record) {
                                var notificationTitle = record.event_type_name,
                                    notificationBody = $(record.name_html).text(),
                                    notificationId = record.id,
                                    requireInteraction = true, //true,
                                    iconUrl = 'custom/PxRoutines/NeedToDoViewer/Images/default_icon.png';

                                if (!_.isEmpty(record.icon)) {
                                    iconUrl = app.api.buildFileURL({
                                        module: 'PX_NeedToDoEventTypes',
                                        id: record.event_type_id,
                                        field: 'icon'
                                    });
                                }

                                notificationBody += "\n" + "Control Date: " + app.date(record.control_date).format(app.date.convertFormat(app.user.getPreference('datepref')));
                                ;
                                if ((!_.isEmpty(record.control_date_type) && record.control_date_type != 'date')) {
                                    notificationBody += " " + app.date(record.control_date).format(app.date.convertFormat(app.user.getPreference('timepref')));
                                }

                                notifyMe(notificationTitle, {
                                    body: notificationBody,
                                    icon: iconUrl,
                                    tag: notificationId,
                                    timestamp: app.date().unix(),
                                    requireInteraction: requireInteraction,
                                    data:{
                                        ntdvEventUrl: '#PX_NeedToDoEvents/' + record.id
                                    }
                                });
                            });

                        }
                    });


                    function notifyMe(title, options) {
                        // debugger;
                        if (!("Notification" in window)) {
                            alert("This browser does not support desktop notification");
                        }
                        else if (Notification.permission === "granted") {
                            var notification = new Notification(title, options);
                            notification.onclick = function (e) {
                                e.preventDefault();
                                var win = window.open(this.data.ntdvEventUrl, '_blank');
                                win.focus();
                            };
                        }
                        else if (Notification.permission !== 'denied') {
                            Notification.requestPermission(function (permission) {
                                if (!('permission' in Notification)) {
                                    Notification.permission = permission;
                                }
                                if (permission === "granted") {
                                    var notification = new Notification(title, options);
                                    notification.onclick = function (e) {
                                        e.preventDefault();
                                        var win = window.open(this.data.ntdvEventUrl, '_blank');
                                        win.focus();
                                    };
                                }
                            });
                        }
                    }

                    datetime = app.date().formatServer();
                    return datetime;
                };

            window.setInterval(function (date) {
                date = notificationFunc(date);
            }, delayInMilliseconds, date);

        }

    });
})(SUGAR.App);

