<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Indexing;

class IndexRelations
{
    protected $db;

    static $eventTypeIds = array();

    public function __construct()
    {
        $this->db = \DBManagerFactory::getInstance();
    }

    public function addRelation(array $data){
        $moduleName = $data['module_name'];
        $recordId = $data['record_id'];
        $eventTypeId = $data['event_type_id'];
        $relatedModuleName = $data['related_module_name'];
        $relatedRecordId = $data['related_record_id'];
        $linkName = $data['link_name'];

        if(!isset(self::$eventTypeIds[$moduleName][$recordId])) {
            $ntdvEventsBean = \BeanFactory::getBean('PX_NeedToDoEvents');
            $query = new \SugarQuery();
            $query->from($ntdvEventsBean, array('team_security' => false));
            $query->select(array('id'));
            $query->where()->equals('object_type', $moduleName);
            $query->where()->equals('object_id', $recordId);
            $query->where()->equals('event_type_id', $eventTypeId);
            $eventId = $query->getOne();

//            $sql = "
//                SELECT px_needtodoevents.id
//                FROM px_needtodoevents
//                WHERE
//                    px_needtodoevents.object_type='$moduleName' AND
//                    px_needtodoevents.object_id='$recordId' AND
//                    px_needtodoevents.event_type_id='$eventTypeId'
//            ";
//            $eventId = $this->db->getOne($sql);
        }

        if(!empty($eventId)){
            $ntdvRelatesBean = \BeanFactory::getBean('PX_NeedToDoRelates');
            $query = new \SugarQuery();
            $query->from($ntdvRelatesBean, array('team_security' => false));
            $query->select(array('id'));
            $query->where()->equals('parent_type', $relatedModuleName);
            $query->where()->equals('parent_id', $relatedRecordId);
            $query->where()->equals('relate_type', 'Target');
            $query->where()->equals('link_name', $linkName);
            $query->where()->equals('event_id', $eventId);
            $ntdvParentsId = $query->getOne();

            if(empty($ntdvParentsId)) {
                $ntdvRelatesBean->parent_type = $relatedModuleName;
                $ntdvRelatesBean->parent_id = $relatedRecordId;
                $ntdvRelatesBean->event_id = $eventId;
                $ntdvRelatesBean->relate_type = 'Target';
                $ntdvRelatesBean->link_name = $linkName;
                $ntdvRelatesBean->save();
//
//                global $timedate, $current_user;
//                $newId = \Sugarcrm\Sugarcrm\Util\Uuid::uuid1();
//                $currentDatetime = $timedate->nowDb();
//                $currentUserId = $current_user->id;
//
//                $sqlAddRelation = "
//                    INSERT INTO px_ntdv_parents
//                        (id, date_entered, created_by, description, parent_type, parent_id, event_id, link_name)
//                    VALUES
//                        (
//                            '$newId',
//                            '$currentDatetime',
//                            '$currentUserId',
//                            '',
//                            '$relatedModuleName',
//                            '$relatedRecordId',
//                            '$eventId',
//                            '$linkName'
//                        )
//                ";
//                $this->db->query($sqlAddRelation);
            }
        }
    }


    public function removeRelation(array $data){

        $moduleName = $data['module_name'];
        $recordId = $data['record_id'];
        $eventTypeId = $data['event_type_id'];
        $relatedModuleName = $data['related_module_name'];
        $relatedRecordId = $data['related_record_id'];
        $linkName = $data['link_name'];

        $sql = "
            SELECT px_needtodoevents.id 
            FROM px_needtodoevents
            WHERE 
                px_needtodoevents.object_type='$moduleName' AND 
                px_needtodoevents.object_id='$recordId' AND 
                px_needtodoevents.event_type_id='$eventTypeId'
        ";
        $eventId = $this->db->getOne($sql);

        if(!empty($eventId)){
            $removeRelationSQL = "
                DELETE FROM px_ntdv_parents
                WHERE 
                    px_ntdv_parents.parent_type = '$relatedModuleName' AND 
                    px_ntdv_parents.parent_id = '$relatedRecordId' AND
                    px_ntdv_parents.relate_type = 'Target' AND
                    px_ntdv_parents.link_name = '$linkName' AND  
                    px_ntdv_parents.event_id = '$eventId'  
            ";
            $this->db->query($removeRelationSQL);
        }
    }

}