<?php

/**
 * Need To Do Viewer Plugin License visibility
 */
class PxNeedToDoLicenseVisibility extends SugarVisibility
{
    /**
     * {@inheritdoc}
     */
    public function addVisibilityWhere(&$query)
    {
        $licenseIsValid = true;
        try {
            require_once 'custom/PxRoutines/NeedToDoViewer/Package/License/Control.php';
            $control = new \Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package\License\Control();
            $control->checkLicenseForCurrentUser();
        }catch(Exception $e){
            $licenseIsValid = false;
        }

        $license_where = "1 = " . ($licenseIsValid ? '1' : '0');

        if (!empty($query)) {
            $query .= " AND $license_where";
        } else {
            $query = $license_where;
        }

        return $query;
    }

    /**
     * {@inheritdoc}
     */
    public function addVisibilityWhereQuery(SugarQuery $sugarQuery, $options = array())
    {
        $where = null;
        $this->addVisibilityWhere($where);

        if (!empty($where)) {
            $sugarQuery->where()->queryAnd()->addRaw($where);
        }

        return $sugarQuery;
    }
}
