<?php

class PX_IndexNeedToDoEventsApi extends ModuleApi {

    public function registerApiRest() {
        return array(
            'enum' => array(
                'reqType' => 'POST',
                'path' => array('PX_NeedToDoEventTypes','index'),
                'pathVars' => array('', ''),
                'method' => 'indexNeedToDoEvents',
                'shortHelp' => 'This method indexes Need To Do Events',
                'longHelp' => '', //TODO: Write Long Help for this
            ),
        );
    }

    public function indexNeedToDoEvents(ServiceBase $api, array $args)
    {
        $this->requireArgs($args, array('eventTypeIds'));

        $eventTypeIds = $args['eventTypeIds'];
        $manualEventTypesCollector = new \Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Indexing\ManualEventTypesCollector($eventTypeIds);
        $eventTypes = $manualEventTypesCollector->getEventTypesForIndexing();
        $indexing = new \Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Indexing\Indexing();
        $indexing->index($eventTypes);

        return array(
            'result' => 'success'
        );
    }
}
