({
    extendsFrom: 'EnumField',

    initialize: function() {
        this._super('initialize', arguments);

        if(this.name == 'target_attribute_name' || this.fieldIsTemplateFieldValuePart() || this.fieldIsParentRelateListPart()){
            this.model.on('change:target_module', this.onTargetModuleChange, this);
        }

        if(this.fieldIsTemplateAttributeNamePart()){
            this.model.on('change:lb_template_name', this.onFlowchartTemplateNameChange, this);
        }

        // if(this.fieldIsTemplateFieldValuePart()){
        //     this.model.on('change:target_module', this.onTargetModuleChange, this);
        // }
    },

    onTargetModuleChange: function(){
        this.reloadEnumOptions();
    },

    onFlowchartTemplateNameChange: function(){
        this.reloadEnumOptions();
    },

    fieldIsTemplateAttributeNamePart: function(){
        return !_.isEmpty(this.def) && !_.isEmpty(this.def['parentFieldName']) && this.def.parentFieldName == 'lb_template_arguments' &&
            !_.isEmpty(this.def['argumentPart']) && this.def.argumentPart == 'template-attribute';
    },

    fieldIsTemplateFieldValuePart: function(){
        return !_.isEmpty(this.def) && !_.isEmpty(this.def['parentFieldName']) && this.def.parentFieldName == 'lb_template_arguments' &&
            !_.isEmpty(this.def['argumentPart']) && this.def.argumentPart == 'target-field';
    },

    fieldIsParentRelateListPart: function(){
        return !_.isEmpty(this.def) && !_.isEmpty(this.def['parentFieldName']) && this.def.parentFieldName == 'target_entity_parent_list';
    },

    reloadEnumOptions: function(){
        if(!this.model.inSync) {
            this.model.set(this.name, '');
        }

        this.items = null;
        this._render();
    },

    loadEnumOptions: function(fetch, callback, error) {
        var targetModuleName = this.model.get('target_module');
        if(this.name == 'target_attribute_name'){
            this.loadAttributesForTargetModule(fetch, callback, error, targetModuleName, this.name)
        }else if(this.fieldIsTemplateAttributeNamePart()){
            // console.info('::::::::::::: TemplateAttributeName::this.name ', this.name);
            var lbTemplateID = this.model.get('lb_template_id');
            this.loadAttributesForTargetModule(fetch, callback, error, lbTemplateID, 'lb_template_arguments_list');
        }else if(this.fieldIsTemplateFieldValuePart()){
            // console.info('::::::::::::: TemplateFieldValue::this.name ', this.name);
            this.loadAttributesForTargetModule(fetch, callback, error, targetModuleName, 'lb_template_arguments_values');
        }else if(this.fieldIsParentRelateListPart()){
            this.loadAttributesForTargetModule(fetch, callback, error, targetModuleName, 'target_entity_parent_list');
        }else {
            // console.info('::::::::::::: this.name ', this.name);
            this._super('loadEnumOptions', [fetch, callback, error]);
        }
    },

    loadAttributesForTargetModule: function(fetch, callback, error, keyFieldVal, fieldName){
        keyFieldVal = keyFieldVal || 'unset';
        var self = this;
        var _module = this.getLoadEnumOptionsModule();
        var _itemsKey = 'cache:' + _module + ':' + keyFieldVal + ':' + fieldName + ':items';

        this.items = this.def.options || this.context.get(_itemsKey);

        fetch = fetch || false;

        if (fetch || !this.items) {
            this.isFetchingOptions = true;
            var _key = 'request:' + _module + ':' + keyFieldVal + ':' + fieldName;
            //if previous request is existed, ignore the duplicate request
            if (this.context.get(_key)) {
                var request = this.context.get(_key);
                request.xhr.done(_.bind(function (o) {
                    if (this.items !== o) {
                        this.items = o;
                        callback.call(this);
                    }
                }, this));
            } else {
                var url = app.api.buildURL(_module + '/enum/' + fieldName + '/' + keyFieldVal);
                var request = app.api.call('read', url, {}, {
                    // var request = app.api.enumOptions(_module, self.name, {
                    success: function (o) {
                        if (self.disposed) {
                            return;
                        }
                        if (self.items !== o) {
                            self.items = o;
                            self.context.set(_itemsKey, self.items);
                        }
                    },
                    error: function (e) {
                        if (self.disposed) {
                            return;
                        }

                        if (error) {
                            error(e);
                        }

                        // Continue to use Sugar7's default error handler.
                        if (_.isFunction(app.api.defaultErrorHandler)) {
                            app.api.defaultErrorHandler(e);
                        }

                        self.items = {'': app.lang.get('LBL_NO_DATA', self.module)};
                    },
                    complete: function () {
                        if (!self.disposed) {
                            self.context.unset(_key);
                            callback.call(self);
                        }
                    }
                });
                this.context.set(_key, request);
            }
        } else if (_.isString(this.items)) {
            this.items = app.lang.getAppListStrings(this.items);
        }
    },

    _getDefaultOption: function (optionsKeys) {
        if(this.name == 'target_module')
            return '';
        else
            return this._super('_getDefaultOption', [optionsKeys]);
    },

    getSelect2Options: function(optionsKeys){
        var select2Options = this._super('getSelect2Options', [optionsKeys]);

        if(!_.isEmpty(this.def['selectPlaceholder'])) {
            var selectPlaceholder = app.lang.get(this.def['selectPlaceholder'], this.module);
            select2Options.placeholder = "Select %FIELD_PLACEHOLDER%...".replace('%FIELD_PLACEHOLDER%', selectPlaceholder);
        }

        return select2Options;
    }
})
