({
    className: 'ntdv-settings',

    events: {
        'click .add-users-button:not(.disabled)': 'addUsersClicked',
        'click .record-panel-header': 'togglePanelEvent',
    },

    panelsStates: {
        'panel_ntdv_license_data': '',
        'panel_ntdv_add_users': '',
        'panel_ntdv_license_details': ''
    },

    initialize: function (options) {
        this._super("initialize", [options]);

        this.context.on('users:disableAddButton', this.disableAddUsersButton, this);
        this.context.on('users:enableAddButton', this.enableAddUsersButton, this);
        this.context.on('users:hidePanel', this.hideUsersPanel, this);
        this.context.on('users:showPanel', this.showUsersPanel, this);
        this.context.on('settings:close', function () {
            app.router.goBack();
        });
    },

    _loadTemplate: function(options) {
        // if(!this.userHasAccess()) {
        //     // this.template = app.template.getLayout(this.name + '.noaccess', this.module);
        //     this.template = app.template.getLayout('license-settings.noaccess', 'PX_Timeline');
        // }else
            this._super("_loadTemplate", [options]);
    },

    addComponent: function(component, def) {
        if(!this.userHasAccess() && component.name != 'license-settings-headerpane') {
            return;
        }else{
            this._super("addComponent", [component, def]);
        }
    },

    userHasAccess: function(){
        return app.acl.hasAccess('admin', 'Administration');
    },

    _render: function () {
        this._super("_render");

        this.initPanelStates();
    },

    addUsersClicked: function () {
        this.context.trigger('users:add');
    },

    togglePanelEvent: function(e) {
        var $panelHeader = this.$(e.currentTarget);

        this.togglePanel($panelHeader);

        var panelName = $panelHeader.parent().data('panelname');
        var state = 'collapsed';
        if ($panelHeader.next().is(":visible")) {
            state = 'expanded';
        }
        this.savePanelState(panelName, state);
    },

    togglePanel: function($panelHeader) {
        if ($panelHeader && $panelHeader.next()) {
            $panelHeader.next().toggle();
            $panelHeader.toggleClass('panel-inactive panel-active');
        }
        if ($panelHeader && $panelHeader.find('i')) {
            $panelHeader.find('i').toggleClass('fa-chevron-up fa-chevron-down');
        }
    },

    savePanelState: function(panelID, state) {
        if (this.createMode) {
            return;
        }
        var panelKey = app.user.lastState.key(panelID + ':tabState', this);
        app.user.lastState.set(panelKey, state);
    },

    initPanelStates: function(){
        // set states
        var panelNames = ['panel_ntdv_license_data', 'panel_ntdv_add_users', 'panel_ntdv_license_details'];
        _.each(panelNames, function(panelName){
            var panelKey = app.user.lastState.key(panelName + ':tabState', this);
            var panelState = app.user.lastState.get(panelKey);
            var $panelHeader = this.$('.record-panel[data-panelname="' + panelName + '"] .record-panel-header');
            if($panelHeader.length){
                // if(panelState == 'expanded'){
                //     this.expandPanel($panelHeader);
                // }
                // else if(panelState == 'collapsed'){
                //     this.collapsePanel($panelHeader);
                // }
            }
        }, this);
    },

    expandPanel: function($panelHeader) {
        $panelHeader.removeClass('panel-inactive')
        $panelHeader.addClass('panel-inactive')
        if ($panelHeader && $panelHeader.next()) {
            $panelHeader.next().show();
        }
        if ($panelHeader && $panelHeader.find('i')) {
            $panelHeader.find('i').removeClass('fa-chevron-down');
            $panelHeader.find('i').addClass('fa-chevron-up');
        }
    },

    collapsePanel: function($panelHeader) {
        $panelHeader.removeClass('panel-inactive')
        $panelHeader.addClass('panel-inactive')
        if ($panelHeader && $panelHeader.next()) {
            $panelHeader.next().hide();
        }
        if ($panelHeader && $panelHeader.find('i')) {
            $panelHeader.find('i').removeClass('fa-chevron-up');
            $panelHeader.find('i').addClass('fa-chevron-down');
        }
    },

    showUsersPanel: function(){
        this.$('div[data-panelname="panel_ntdv_add_users"]').show();
    },

    hideUsersPanel: function(){
        this.$('div[data-panelname="panel_ntdv_add_users"]').hide();
    },

    enableAddUsersButton: function(){
        this.$('.add-users-button').removeClass('disabled');
    },

    disableAddUsersButton: function(){
        this.$('.add-users-button').addClass('disabled');
    }

})
