({

    extendsFrom: 'RecordlistView',

    initialize: function(options) {
        this._super('initialize', [options]);

        this.usePartialsFromGlobalRecordListView();

        this.context.on("list:index:fire", this.indexEventType, this);
    },

    usePartialsFromGlobalRecordListView: function(){
        this.options = this.options || {};
        this.options['templateOptions'] = this['templateOptions'] || {};
        this.options.templateOptions['partials'] = this.options.templateOptions['partials'] || {};
        this.options.templateOptions.partials['row'] = app.template.getView('recordlist' + '.' + 'row');
        this.options.templateOptions.partials['row-header'] = app.template.getView('recordlist' + '.' + 'row-header');
    },

    indexEventType: function (model) {
        var ids = [];

        var models = [];

        if (this.context.get('mass_collection').length) {
            models = this.context.get('mass_collection').models;
        }else {
            models = [model];
        }

        ids = _.map(models, function(m){ return m.get('id'); });

        var url = app.api.buildURL('PX_NeedToDoEventTypes/index');
        app.api.call('create', url, { eventTypeIds: ids }, {
            success: _.bind(function (response) {
            }, this),
            error: function (error) {
            },
            complete: _.bind(function(){
                app.alert.dismiss("ntdv_index_event_type");
            }, this)
        });

        app.alert.show('ntdv_index_event_type', {
            level: 'process',
            title: app.lang.get('LBL_LOADING'),
            autoClose: false
        });
    },
})
