<?php

$viewdefs['PX_NeedToDoEvents']['base']['view']['need-to-do-events-dashlet'] = array(
    'dashlets' => array(
        array(
            'label' => 'LBL_PX_NEEDTODOEVENTS_DASHLET_NAME',
            'description' => 'LBL_PX_NEEDTODOEVENTS_DASHLET_DESCRIPTION',
            'config' => array(
                'module' => 'PX_NeedToDoEvents',
                'visibility' => [],
                'limit' => 5,
            ),
            'preview' => array(
                'module' => 'PX_NeedToDoEvents',
                'visibility' => [],
                'limit' => 5,
            ),
            'filter' => array(
                'view' => array(
                    'record',
                    'records'
                )
            )
        ),
    ),
    'custom_toolbar' => array(
        'buttons' => array(
            array(
                "type" => "dashletaction",
                "css_class" => "dashlet-toggle btn btn-invisible minify",
                "icon" => "fa-chevron-up",
                "action" => "toggleMinify",
                "tooltip" => "LBL_DASHLET_MINIMIZE",
            ),
            array(
                'dropdown_buttons' => array(
                    array(
                        'type' => 'dashletaction',
                        'action' => 'editClicked',
                        'label' => 'LBL_DASHLET_CONFIG_EDIT_LABEL',
                    ),
                    array(
                        'type' => 'dashletaction',
                        'action' => 'refreshClicked',
                        'label' => 'LBL_DASHLET_REFRESH_LABEL',
                    ),
                    array(
                        'type' => 'dashletaction',
                        'action' => 'toggleClicked',
                        'label' => 'LBL_DASHLET_MINIMIZE',
                        'event' => 'minimize',
                    ),
                    array(
                        'type' => 'dashletaction',
                        'action' => 'removeClicked',
                        'label' => 'LBL_DASHLET_REMOVE_LABEL',
                    ),
                ),
            ),
        ),
    ),
    'config' => array(
        'columns' => 2,
        'labelsOnTop' => true,
        'placeholders' => true,
        'fields' => array(
            array(
                'name' => 'visibility',
                'label' => 'LBL_PX_NTDV_DASHLET_CONFIGURE_VISIBILITY',
                'type' => 'enum',
//                'type' => 'multienum',
                'isMultiSelect' => true,
                'options' => 'px_ntdv_dashlet_visibility_options',
            ),
            array(
                'name' => 'limit',
                'label' => 'LBL_DASHLET_CONFIGURE_DISPLAY_ROWS',
                'type' => 'enum',
                'options' => 'dashlet_limit_options',
            ),
            array(
                'name' => 'auto_refresh',
                'label' => 'LBL_REPORT_AUTO_REFRESH',
                'type' => 'enum',
                'options' => 'sugar7_dashlet_auto_refresh_options',
            ),
//            array(
//                'name' => 'enable_sticking_features',
//                'label' => 'Enable Sticking Features',
//                'type' => 'enum',
//                'options' => 'bselect_type_dom',
//            ),
            array(
                'name' => 'dashlet_height',
                'label' => 'LBL_PX_NTDV_DASHLET_HEIGHT',
                'type' => 'int',
            ),
        ),
    ),

    'panels' => array(
        array(
            'name' => 'panel_body',
            'columns' => 2,
            'labelsOnTop' => true,
            'placeholders' => true,
            'fields' => array(
                array(
                    'name' => 'visibility',
                    'label' => 'LBL_DASHLET_CONFIGURE_MY_ITEMS_ONLY',
                    'type' => 'enum',
                    'options' => 'tasks_visibility_options',
                ),
                array(
                    'name' => 'limit',
                    'label' => 'LBL_DASHLET_CONFIGURE_DISPLAY_ROWS',
                    'type' => 'enum',
                    'options' => 'tasks_limit_options',
                ),
            ),
        ),
    ),


    'tabs' => array(
        'current' => array(
//            'active' => true,
            'value' => 'current',
            'label' => 'LBL_NTDV_DASHLET_TAB_CURRENT',
        ),
        'overdue' => array(
            'value' => 'overdue',
            'label' => 'LBL_NTDV_DASHLET_TAB_OVERDUE',
        ),
        'future' => array(
            'value' => 'future',
            'label' => 'LBL_NTDV_DASHLET_TAB_FUTURE',
        ),
    ),
    'visibility_labels' => array(
        'current' => 'LBL_NTDV_DASHLET_TAB_CURRENT',
        'overdue' => 'LBL_NTDV_DASHLET_TAB_OVERDUE',
        'future' => 'LBL_NTDV_DASHLET_TAB_FUTURE',
    ),
);
