({
    events: {
        'click .toggle-rows': 'toggleRecords'
    },

    tagName: "div",
    className: "ntdv-group",
    plugins: ['RelativeTime', 'FileDragoff'],

    dateLabel: '',
    needToDoRows: [],
    isCollapsed: false,

    totalAmount: 0,

    faIconClassCollapsed: 'fa-chevron-up',
    faIconClassExpanded: 'fa-chevron-down',

    targetDatetimeFieldName: 'control_date',
    groupId: '',

    initialize: function(options) {
        app.view.View.prototype.initialize.call(this, options);
    },

    _renderHtml: function(model) {
        this._setGroupId();
        this._setDateLabel();
        app.view.View.prototype._renderHtml.call(this);
    },

    _setGroupId: function() {
        var control_date = this.model.get(this.targetDatetimeFieldName);
        this.groupId = app.date(control_date).format("YYYY-MM-DD");
    },

    _setDateLabel: function() {
        var control_date = this.model.get(this.targetDatetimeFieldName);
        // this.dateLabel = app.date(control_date).format("dddd, MMMM Do, YYYY");
        this.dateLabel = app.date(control_date).format(app.date.convertFormat(app.user.getPreference('datepref')));

    },

    refreshAmount: function(displayedAmount, totalAmount){
        displayedAmount = displayedAmount || this.totalAmount;

        var label = app.lang.get('LBL_COUNT_DISPLAYED_ALL_RECORDS', this.module);
        if(!_.isUndefined(totalAmount) && displayedAmount < totalAmount){
            label = app.lang.get('LBL_COUNT_DISPLAYED_PART_OF_RECORDS', this.module);
            label = label.replace("total_amount", "" + totalAmount + "");
            this.totalAmount = totalAmount;
        }else if(!this.totalAmount){
            this.totalAmount = displayedAmount;
        }
        label = label.replace("displayed_amount", "" + displayedAmount + "");

        this.$el.find('.ntdv-count').html(label);
    },

    addChildView: function(chidView){
        this.needToDoRows.push(chidView);
    },

    allNtdvRecordsLoaded: function(){
        return this.totalAmount == this.needToDoRows.length;
    },

    toggleRecords: function(){
        if(this.isCollapsed){
            this.expandRecords();
        }else{
            this.collapseRecords();
        }
    },

    collapseRecords: function(){
        var groupContainer = this.$el.find('.ntdv-group-container'),
            groupHeight = this.$el.find('.ntdv-list')[0].offsetHeight - groupContainer[0].offsetHeight,
            // groupOffset = parseInt(this.$el.find('.ntdv-group-container').css('top')) || 0;
            groupOffset = this.layout.getDateGroupContainerTopPosition(this.$el);

        // _.each(this.needToDoRows, function(view){
        //     view.hide();
        // })
        this.isCollapsed = true;
        this.$el.find('.' + this.faIconClassExpanded).hide();
        this.$el.find('.' + this.faIconClassCollapsed).show();
        groupContainer.addClass('collapsed');
        this.$el.closest('.ntdv-group').addClass('collapsed');

        var stickyGroupEl = this.layout.getStickyGroupEl();
        if(stickyGroupEl && this.cid == stickyGroupEl.data('id')) {
            this.layout.updateScrollPositionOnToggleGroup(groupContainer, groupHeight, groupOffset);
        }
    },

    expandRecords: function(){
        // _.each(this.needToDoRows, function(view){
        //     view.show();
        // })
        this.isCollapsed = false;
        this.$el.find('.' + this.faIconClassCollapsed).hide();
        this.$el.find('.' + this.faIconClassExpanded).show();
        this.$el.find('.ntdv-group-container').removeClass('collapsed');

        this.$el.closest('.ntdv-group').removeClass('collapsed');
    }
})
