<?php

/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/Resources/Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */

$dictionary['PX_NeedToDoEvents'] = array(
    'table' => 'px_needtodoevents',
    'audited' => true,
    'activity_enabled' => false,
    'duplicate_merge' => true,
    'fields' => array(
        'name_html' => array(
            'name' => 'name_html',
            'vname' => 'LBL_NAME_HTML',
            'type' => 'longhtml',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'control_date' => array(
            'required' => true,
            'name' => 'control_date',
            'vname' => 'LBL_CONTROL_DATE',
            'type' => 'datetimecombo',
            'massupdate' => false,
            'no_default' => false,
            'comments' => '',
            'help' => '',
            'importable' => 'true',
            'duplicate_merge' => 'disabled',
            'duplicate_merge_dom_value' => '0',
            'audited' => false,
            'reportable' => true,
            'unified_search' => false,
            'merge_filter' => 'disabled',
            'pii' => false,
            'calculated' => false,
            'size' => '20',
            'enable_range_search' => false,
            'dbType' => 'datetime',
            'hideacl' => true,
        ),
//        'control_date_type' => array(
//            'required' => true,
//            'name' => 'control_date_type',
//            'vname' => 'LBL_CONTROL_DATE_TYPE',
//            'type' => 'enum',
//            'options' => 'px_target_attribute_type_options',
//            'len' => '100',
//            'source' => 'non-db',
//        ),
        'control_date_type' => array(
            'required' => true,
            'name' => 'control_date_type',
            'vname' => 'LBL_CONTROL_DATE_TYPE',
            'type' => 'enum',
            'options' => 'px_ntdv_control_date_type_options',
            'len' => 20,
            'reportable' => true,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'object_id' => array(
            'name' => 'object_id',
            'vname' => 'LBL_OBJECT_ID',
            'type' => 'id',
            'len' => 36,
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'filter_object_type' => array(
            'name' => 'filter_object_type',
            'vname' => 'LBL_OBJECT_TYPE',
            'type' => 'enum',
            'function' => 'PX_NeedToDoEventTypes::getTargetModuleList',
            'source' => 'non-db',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'object_type' => array(
            'name' => 'object_type',
            'vname' => 'LBL_OBJECT_TYPE',
            'type' => 'enum',
            'function' => 'PX_NeedToDoEventTypes::getTargetModuleList',
            'len' => 100,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'object_name' => array(
            'name' => 'object_name',
            'vname' => 'LBL_OBJECT_NAME',
            'type' => 'px-parent',
            'type_name' => 'object_type',
            'id_name' => 'object_id',
            'link_name' => 'object_link',
            'source' => 'non-db',
            'len' => 100,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'event_type' => array(
            'name' => 'event_type',
            'type' => 'link',
            'relationship' => 'px_needtodoeventtypes_needtodoevents',
            'source' => 'non-db',
            'side' => 'right',
            'vname' => 'LBL_EVENT',
            'massupdate' => false,
            'hideacl' => true,
        ),
        'event_type_id' => array(
            'required' => false,
            'name' => 'event_type_id',
            'vname' => 'LBL_EVENT_TYPE_ID',
            'type' => 'id',
            'massupdate' => false,
            'no_default' => false,
            'comments' => '',
            'help' => '',
            'importable' => 'true',
            'duplicate_merge' => 'disabled',
            'duplicate_merge_dom_value' => 0,
            'audited' => false,
            'reportable' => false,
            'unified_search' => false,
            'merge_filter' => 'disabled',
            'calculated' => false,
            'len' => 36,
            'size' => '20',
            'hideacl' => true,
        ),
        'event_type_name' => array(
            'required' => false,
            'source' => 'non-db',
            'name' => 'event_type_name',
            'vname' => 'LBL_EVENT_TYPE_NAME',
            'type' => 'relate',
            'massupdate' => false,
            'no_default' => false,
            'comments' => '',
            'help' => '',
            'importable' => 'true',
            'duplicate_merge' => 'disabled',
            'duplicate_merge_dom_value' => '0',
            'audited' => true,
            'reportable' => true,
            'unified_search' => false,
            'merge_filter' => 'disabled',
            'calculated' => false,
            'len' => '255',
            'size' => '20',
            'link' => 'event_type',
            'id_name' => 'event_type_id',
            'module' => 'PX_NeedToDoEventTypes',
            'rname' => 'name',
            'quicksearch' => 'enabled',
            'studio' => 'visible',
            'readonly' => false,
            'hideacl' => true,
        ),
        'event_type_icon' => array(
            'name' => 'event_type_icon',
            'vname' => 'LBL_EVENT_TYPE_ICON',
            'type' => 'relate',
            'source' => 'non-db',
            'link' => 'event_type',
            'id_name' => 'event_type_id',
            'module' => 'PX_NeedToDoEventTypes',
            'rname' => 'icon',
            'hideacl' => true,
            'massupdate' => false,
        ),
        'notify_beforehand' => array(
            'name' => 'notify_beforehand',
            'vname' => 'LBL_NOTIFY_BEFOREHAND',
            'type' => 'relate',
            'source' => 'non-db',
            'link' => 'event_type',
            'id_name' => 'event_type_id',
            'module' => 'PX_NeedToDoEventTypes',
            'rname' => 'notify_beforehand',
            'hideacl' => true,
            'massupdate' => false,
        ),
        'object_attribute_name' => array(
            'required' => true,
            'name' => 'object_attribute_name',
            'vname' => 'LBL_OBJECT_ATTRIBUTE_NAME',
            'type' => 'varchar',
            'len' => '100',
            'source' => 'non-db',
            'massupdate' => false,
            'hideacl' => true,
        ),
        'icon' => array(
            'name' => 'icon',
            'vname' => 'LBL_ICON',
            'type' => 'varchar',
            'source' => 'non-db',
            'len' => 100,
            'reportable' => false,
            'massupdate' => false,
            'importable' => false,
            'hideacl' => true,
        ),
        'parents_list' => array(
            'name' => 'parents_list',
            'vname' => 'LBL_PARENTS_LIST',
            'type' => 'longtext',
            'source' => 'non-db',
            'required' => false,
            'reportable' => false,
            'hideacl' => true,
            'massupdate' => false,
        ),
        /* COMMENTS */
        'comment_count' => array(
            'name' => 'comment_count',
            'type' => 'int',
            'vname' => 'LBL_COMMENT_COUNT',
            'required' => true,
            'default' => 0,
            'importable' => false,
            'exportable' => false,
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'last_comment' => array(
            'name' => 'last_comment',
            'type' => 'json',
            'vname' => 'LBL_LAST_COMMENT',
            'dbType' => 'longtext',
            'required' => true,
            'importable' => false,
            'exportable' => false,
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'comments' => array(
            'name' => 'comments',
            'type' => 'link',
            'vname' => 'LBL_COMMENTS',
            'relationship' => 'px_needtodoevents_comments',
            'link_type' => 'many',
            'module' => 'PX_NeedToDoViewerComments',
            'bean_name' => 'PX_NeedToDoViewerComments',
            'source' => 'non-db',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'has_new_comments' => array(
            'name' => 'has_new_comments',
            'type' => 'bool',
            'vname' => 'LB_HAS_NEW_COMMENTS',
            'default' => '0',
            'source' => 'non-db',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'notify_date' => array(
            'required' => false,
            'name' => 'notify_date',
            'vname' => 'LBL_NOTIFY_DATE',
            'type' => 'datetimecombo',
            'massupdate' => false,
            'no_default' => false,
            'comments' => '',
            'help' => '',
            'importable' => 'true',
            'duplicate_merge' => 'disabled',
            'duplicate_merge_dom_value' => '0',
            'audited' => false,
            'reportable' => true,
            'unified_search' => false,
            'merge_filter' => 'disabled',
            'pii' => false,
            'calculated' => false,
            'size' => '20',
            'enable_range_search' => false,
            'dbType' => 'datetime',
        ),
        'notify_users_list' => array(
            'name' => 'notify_users_list',
            'type' => 'longtext',
            'vname' => 'LBL_NOTIFY_USERS_LIST',
            'source' => 'non-db',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'context_entities_list' => array(
            'name' => 'context_entities_list',
            'type' => 'longtext',
            'vname' => 'LBL_CONTEXT_ENTITIES_LIST',
            'source' => 'non-db',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'event_status' => array(
            'name' => 'event_status',
            'vname' => 'LBL_EVENT_STATUS',
            'type' => 'enum',
            'options' => 'px_ntdv_dashlet_visibility_options',
            'source' => 'non-db',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'filter_parent_type' => array(
            'name' => 'filter_parent_type',
            'vname' => 'LBL_PARENT_TYPE',
            'type' => 'enum',
            'function' => 'PX_NeedToDoEventTypes::getTargetModuleList',
            'source' => 'non-db',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'parent_id' => array(
            'name' => 'parent_id',
            'vname' => 'LBL_PARENT_ID',
            'type' => 'id',
            'len' => 36,
            'source' => 'non-db',
            'reportable' => false,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'parent_type' => array(
            'name' => 'parent_type',
            'vname' => 'LBL_PARENT_TYPE',
            'type' => 'enum',
            'source' => 'non-db',
            //'options' => 'moduleList',
            'function' => 'PX_NeedToDoEventTypes::getTargetModuleList',
            'len' => 100,
            'massupdate' => false,
            'hideacl' => true,
        ),
        'relates' => array(
            'name' => 'relates',
            'type' => 'link',
            'relationship' => 'px_needtodoevents_relates',
            'module' => 'PX_NeedToDoRelates',
            'bean_name' => 'PX_NeedToDoRelates',
            'source' => 'non-db',
            'vname' => 'LBL_RELATES',
            'massupdate' => false,
            'hideacl' => true,
        )
    ),
    'indices' => array(
        array(
            'name' => 'px_ntdve_control_date_id',
            'type' => 'index',
            'fields' => array(
                'control_date',
                'id',
                'deleted',
            ),
        ),
//        array(
//            'name' => 'px_ntdve_parent_rel',
//            'type' => 'index',
//            'fields' => array(
//                'parent_id',
//                'parent_type',
//                'deleted',
//            ),
//        ),
        array(
            'name' => 'px_ntdve_event_type_id',
            'type' => 'index',
            'fields' => array(
                'event_type_id',
                'deleted',
            ),
        ),
        array(
            'name' => 'px_ntdve_notify_date_id',
            'type' => 'index',
            'fields' => array(
                'notify_date',
                'id',
                'deleted',
            ),
        ),
        array(
            'name' => 'px_ntdve_object_event_type',
            'type' => 'index',
            'fields' => array(
                'object_id',
                'deleted',
                'object_type',
                'event_type_id',
            ),
        ),
    ),
    'relationships' => array(
        'px_needtodoeventtypes_needtodoevents' => array(
            'lhs_module' => 'PX_NeedToDoEventTypes',
            'lhs_table' => 'px_needtodoeventtypes',
            'lhs_key' => 'id',
            'rhs_module' => 'PX_NeedToDoEvents',
            'rhs_table' => 'px_needtodoevents',
            'rhs_key' => 'event_type_id',
            'relationship_type' => 'one-to-many',
        ),
        'px_needtodoevents_comments' => array(
            'lhs_module' => 'PX_NeedToDoEvents',
            'lhs_table' => 'px_needtodoevents',
            'lhs_key' => 'id',
            'rhs_module' => 'PX_NeedToDoViewerComments',
            'rhs_table' => 'px_needtodoviewercomments',
            'rhs_key' => 'parent_id',
            'relationship_type' => 'one-to-many',
        ),
    ),
    'optimistic_locking' => true,
    'unified_search' => true,
    'full_text_search' => true,
);

if (!class_exists('VardefManager')) {
}
VardefManager::createVardef('PX_NeedToDoEvents', 'PX_NeedToDoEvents', array('basic', 'team_security', 'assignable', 'taggable'));

$dictionary['PX_NeedToDoEvents']['acls']['SugarACLPxNeedToDoViewer'] = true;
$dictionary['PX_NeedToDoEvents']['visibility']['PxNeedToDoLicenseVisibility'] = true;