({
    events: {},

    //tagName: "div",
    className: "ntdv-comment-item",


    plugins: ['RelativeTime'/*, 'FileDragoff' /*, 'Taggable'*/],

    commentsCollection: null,

    cacheNamePrefix: "user:avatars:",
    cacheNameExpire: ":expiry",
    expiryTime: 36000000,   //1 hour in milliseconds

    blacklistModules: ['Quotas'],
    _unformattedPost: null,
    //_unformattedComments: {},

    _attachImageSelector: 'img',

    inlineFetch: false,

    commentBlock: null,

    isReply: false,
    commentsNestingLevel: -1,
    canHaveReplies: true,
    expandReplies: false,

    isUnreadMessage: false,
    needToDoEventLayout: null,

    initialize: function(options) {
        //this.defineCustomHbsHelpers();

        this.inlineFetch = !!options.inlineFetch;

        if(!_.isUndefined(options.isReply))
            this.isReply = options.isReply;
        if(!_.isUndefined(options.commentsNestingLevel))
            this.commentsNestingLevel = options.commentsNestingLevel;
        this.canHaveReplies = this.commentsNestingLevel > 0 ? true : false;
        if(!_.isUndefined(options.expandReplies))
            this.expandReplies = options.expandReplies;
        if(!_.isUndefined(options.isUnreadMessage) && options.isUnreadMessage)
            this.isUnreadMessage = options.isUnreadMessage;
        if(!_.isUndefined(options.needToDoEventLayout) && options.needToDoEventLayout)
            this.needToDoEventLayout = options.needToDoEventLayout;

        app.view.View.prototype.initialize.call(this, options);

        if(this.model.get('parent_type') == 'PX_NeedToDoViewerComments'){
            this.isReply = true;
        }

        // this.events['click .comment-btn[data-idAction="' + this.cid + '"]'] = 'toggleReplyBar';
        this.events['click .show-replies-btn[data-idAction="' + this.cid + '"]'] = 'showReplies';

        this.commentBlock = app.view.createView({
            context: this.context,
            name: "need-to-do-event-comments",
            type: "need-to-do-event-comments",
            module: this.module,
            layout: this,
            model: this.model,
            inlineFetch: this.inlineFetch,
            isReply: true, //this.isReply,
            commentsNestingLevel: this.commentsNestingLevel,
            expandReplies: this.expandReplies,
            needToDoEventLayout: this.needToDoEventLayout
        });

        if(this.isUnreadMessage && this.needToDoEventLayout){
            this.enableScroll();
        }

    },

    showReplies: function(e) {
        var el = e.currentTarget,
            showRepliesButtons = this.$el.find('.show-replies-btn'),
            isHidden = $(el).hasClass('active'),
            commentListEl = this.$el.find('.comments-list').first();
        this.commentBlock.slideShowNeedToDoEventComments(commentListEl, function(){});

        // this.commentBlock.toggleReplyBar(e.currentTarget);
        showRepliesButtons.toggleClass('active', !isHidden)
            .attr('aria-pressed', isHidden);
    },

    _renderHtml: function(model) {
        //var isReplyBarOpen = this.$(".comment-btn").hasClass("active") && this.$(".comment-btn").is(":visible"),
        //    replyVal = this.$(".reply").html();

        this.processAvatars();
        this.formatAllTagsAndLinks();

        app.view.View.prototype._renderHtml.call(this);

        if(this.canHaveReplies) {
            this.$el.find('.response:first').prepend(this.commentBlock.$el);
            this.commentBlock.render();
        }

        //if (isReplyBarOpen) {
        //    this.toggleReplyBar();
        //    this.$(".reply").html(replyVal);
        //}
        this._addBrokenImageHandler();

        if(this.isUnreadMessage && this.needToDoEventLayout) {
            this.readMessageIfInViewport();
        }

        //if(this.model.last)
    },

    processAvatars: function () {
        //var comments = this.model.get('comments');
        //if (comments) {
        //    comments.each(function (comment) {
        var commentPictureUrl = this.getAvatarUrlForUser('comment');
        this.model.set('picture_url', commentPictureUrl);
            //}, this);
        //}
    },

    getAvatarUrlForUser: function (activityType){
        var createdBy = this.model.get('created_by'),
            hasPicture = this.checkUserHasPicture(activityType);

        return hasPicture ? this.buildAvatarUrl(createdBy) : '';
    },

    checkUserHasPicture: function () {
        var createdBy = this.model.get('created_by'),
            hasPicture;

        // If processing the current user's avatar, no need to fetch
        if (createdBy === app.user.get('id')) {
            hasPicture = !_.isEmpty(app.user.get('picture'));
        } else {
            // Check cache
            hasPicture = this.getUserPictureStatus(createdBy);
        }

        // If not current user or cached, call api to check if user has a picture
        if (_.isUndefined(hasPicture)) {
            this.fetchUserPicture();
            hasPicture = false; // Use placeholder until api call finishes
        }

        return hasPicture;
    },

    fetchUserPicture: function() {
        var self = this,
            createdBy = this.model.get('created_by'),
            user = app.data.createBean('Users', {id: createdBy});

        user.fetch({
            fields: ["picture"],
            success: function () {
                var pictureUrl = self.buildAvatarUrl(createdBy),
                    hasPicture = !_.isEmpty(user.get('picture'));

                self.setUserPictureStatus(createdBy, hasPicture);

                // If picture exists, replace the activity image with the user's profile picture
                if (hasPicture) {
                    self.$('#ntdv-comment-author-avatar-' + self.model.get('id')).html("<img src='" + pictureUrl + "' alt='" + self.model.get('created_by_name') + "'>");
                }
            },
            error: function () {
                // Problem retrieving picture, use placeholder
                self.setUserPictureStatus(createdBy, false);
            }
        });
    },

    setUserPictureStatus: function(userId, hasPicture) {
        app.cache.set(this.cacheNamePrefix + userId, hasPicture);
        app.cache.set(this.cacheNamePrefix + userId + this.cacheNameExpire, $.now() + this.expiryTime);
    },

    getUserPictureStatus: function(userId) {
        var hasPicture = app.cache.get(this.cacheNamePrefix + userId),
            cachedTTL = app.cache.get(this.cacheNamePrefix + userId + this.cacheNameExpire);

        return (cachedTTL < $.now()) ? undefined : hasPicture;
    },

    buildAvatarUrl: function(userId) {
        return app.api.buildFileURL({
            module: 'Users',
            id: userId,
            field: 'picture'
        });
    },

    formatAllTagsAndLinks: function() {
        var post = this.model.get('data');

        // Check to see if the post's module is in the blacklist, if so, delete
        // the module property from the object so it will not create a link to the record
        if (post.object && post.object.module && _.contains(this.blacklistModules, post.object.module)) {
            delete post.object.module;
        }

        this.unformatAllTagsAndLinks();

        if (post) {
            this._unformattedPost = post.value;
            post.value = this.formatLinks(post.value);
            post.value = this.formatTags(post.value);
        }

        //this.commentsCollection.each(function(model) {
        //    var data = model.get('data');
        //    this._unformattedComments[model.get('id')] = data.value;
        //    data.value = this.formatLinks(data.value);
        //    data.value = this.formatTags(data.value);
        //}, this);
    },

    unformatAllTagsAndLinks: function() {
        var post = this.model.get('data');
        if (post) {
            post.value = this._unformattedPost || post.value;
        }

        //this.commentsCollection.each(function(model) {
        //    var data = model.get('data');
        //    data.value = this._unformattedComments[model.get('id')] || data.value;
        //}, this);
    },

    formatTags: function(text) {
        var html = '',
            tagRegExp = /@\[([\w]+):([\d\w\-]+):(.+?)\]/g,
            tagTemplate = Handlebars.compile('<span class="label label-{{module}} sugar_tag"><a href="#{{buildRoute module=module id=id}}">{{name}}</a></span>');

        if (text && (text.length > 0)) {
            html = text.replace(tagRegExp, function(str, module, id, name) {
                name = new Handlebars.SafeString(name);
                module = (module === 'Users') ? 'Employees' : module;
                return tagTemplate({module: module, id: id, name: name});
            });
        }

        return $.trim(html);
    },

    formatLinks: function(post) {
        var formattedPost = '';

        if (post && (post.length > 0)) {
            formattedPost = post.replace(this.urlRegExp, function(url) {
                var href = url;
                if ((url.indexOf('http://') !== 0) && (url.indexOf('https://') !== 0)) {
                    href = 'http://' + url;
                }
                return '<a href="' + href + '" target="_blank">' + url + '</a>';
            });
        }

        return formattedPost;
    },

    //TODO: Fixed for Users!
    _addBrokenImageHandler: function() {
        this.$(this._attachImageSelector).on('error', _.bind(function(event) {
            var $brokenImg = $(event.currentTarget);
            $brokenImg.attr('src', 'custom/PxRoutines/NeedToDoViewer/Images/broken_image_icon.png');
        }, this));
    },

    _dispose: function() {
        $(window).off('resize.' + this.cid);
        this.$(this._attachImageSelector).off('error');
        app.view.View.prototype._dispose.call(this);
    },

    enableScroll: function(){
        // var mainLayout = this.needToDoEventLayout;
        // if(!_.isEmpty(mainLayout)){
        //     return;
        // }


        var scrollEl = this.needToDoEventLayout.getCurrentParentEl();
        scrollEl.on("scroll", _.bind(this.onScroll, this));
    },

    disableScroll: function(){
        var scrollEl = this.needToDoEventLayout.getCurrentParentEl();
        scrollEl.off("scroll");
    },

    onScroll: function(){
        if(this.$el.find(".comment[data-id='" + this.model.get('id') + "']").hasClass('new')) {
            this.readMessageIfInViewport();
        }
    },

    readMessageIfInViewport: function(){
        var mainLayout = this.needToDoEventLayout;
        if(_.isEmpty(mainLayout)){
            return;
        }

        if(this.isMessageInViewport()){
            this.readMessage();
        }
    },


    isMessageInViewport: function(){
        var message = this.$el[0],
            top = message.offsetTop,
            height = message.offsetHeight,
            stickyNeedToDoEventEl = this.needToDoEventLayout.getStickyItemEl(),
            stickyNeedToDoEventOffsetHeight = (!_.isEmpty(stickyNeedToDoEventEl) ? stickyNeedToDoEventEl[0].offsetHeight : 0);

        var containerTop = this.needToDoEventLayout.getCurrentParentTop(),
            containerHeight = this.needToDoEventLayout.getCurrentParentEl()[0].offsetHeight;
        while(message.offsetParent) {
            message = message.offsetParent;
            top += (message.offsetTop);
        }

        var isTopVisible = (top - (height/2) - stickyNeedToDoEventOffsetHeight) >= (containerTop) && (top) <= (containerTop + containerHeight),
            isBottomVisible = (top + (height/2)) <= (containerTop + containerHeight);

        return isTopVisible && isBottomVisible;
    },

    readMessage: function(messageContainer){
        var messageContainer = this.$el.find('.comment').first(),
            messageId = this.model.get('id');

        if(!messageId.length || messageContainer.hasClass('in-process') || !messageContainer.hasClass('new'))
            return;

        messageContainer.addClass('in-process');
        var url = app.api.buildURL('px-need-to-do-collaboration/read-message/' + messageId, '', {}, {});
        app.api.call('update', url, {},
            {
                success: _.bind(function (response) {
                    if(response.success){
                        // console.info('response: ', response);
                        messageContainer.removeClass('in-process').removeClass('new');
                        var $dialogContainer = messageContainer.closest('.response').closest('.ntdv-comment-item');
                        this.recalculateNewMessages($dialogContainer);

                        var newMessageDot = messageContainer.find('.ntdv-comment-new-msg'),
                            readMessageDot = messageContainer.find('.ntdv-comment-read-msg');

                        newMessageDot.fadeOut(150, function() {
                            readMessageDot.fadeIn(150);
                        });

                        // setTimeout(function() {
                        //     newMessageDot.fadeOut(300, function() {
                        //         readMessageDot.fadeIn(300);
                        //     });
                        // }, 100);
                    }
                }, this),
                error: _.bind(function () {
                    return;
                }, this)
            });
    },

    recalculateNewMessages: function(dialogContainer){
        var newMessagesContainer = dialogContainer.find('.ntdv-comment-dialog-new-msg-block'),
            newMessagesNumber = dialogContainer.find('.ntdv-comment-dialog-new-msg-count'),
            newMessageContainer = dialogContainer.find('.response .comment.new'),
            needToDoEventContainer = this.$el.closest('.ntdv-container.has-new-messages')
            count = newMessageContainer.length;

        if(!count) {
            newMessagesContainer.fadeOut(300);
            if(!_.isEmpty(needToDoEventContainer) && !needToDoEventContainer.find('.comment.new').length) {
                needToDoEventContainer.removeClass('has-new-messages');
            }
        }else {
            newMessagesNumber.html(count);
        }
    },
})
